steps = 10;
groups = [404;535;592;759;760;850];

% load the data cube from blend_compute
load('blendmodel_weighted_sql_1.mat');
%

% AGGR = cell(size(groups,1), steps+1); % aggregation of data
AGGR_PRESENT_total_cum_pv_by_usr = zeros(size(groups,1),steps+1);% zeros( size(groups,1), steps+1);
AGGR_PRESENT_total_kt_pv_by_usr = zeros(size(groups,1),steps+1);% zeros( size(groups,1), steps+1);

AGGR_PRESENT_total_cum_pv_by_prob = zeros(size(groups,1),steps+1);% zeros( size(groups,1), steps+1);
AGGR_PRESENT_total_kt_pv_by_prob = zeros(size(groups,1),steps+1);% zeros( size(groups,1), steps+1);

AGGR_PRESENT_glob_cum = zeros(size(groups,1),steps+1);
AGGR_PRESENT_glob_kt = zeros(size(groups,1),steps+1);

ALL_by_step = cell(1,steps+1);

sel_usr_mask = [];

glob_pv_cum_by_usr = [];
glob_pv_cum_by_prob = [];
glob_pv_kt_by_usr = [];

time = tic;
sizes = [];
% matlabpool open local 4;
for group_i=1:size(groups,1), % for all groups
	
	line_pv_cum_by_usr = [];
	line_pv_kt_by_usr = [];

	line_pv_cum_by_prob = [];

	for step_i =1:(steps+1), % for all steps
		
		model_data = DATA{group_i, step_i};
		
		if(step_i==1),
			sizes = [sizes, size(cell2mat(model_data.probl_log),1)];
		end;
		
		
		% local mask for selected (>=10 problems and >=10 examples) users
		probl_lrnop = sum( (model_data.probl_lrnop)>0,2);
		examp_lrnop = sum( (model_data.examp_lrnop)>0,2);
		% problems 48, examples64
		loc_sel_usr_mask = and(probl_lrnop>15, examp_lrnop>21); 
% 		loc_sel_usr_mask = and(probl_lrnop>9, examp_lrnop>9); 
	
		if(step_i==1),
			disp(['g',num2str(group_i),'u',num2str(sum(loc_sel_usr_mask))]);
		end;

		idx = find(loc_sel_usr_mask);
% 		pv_cum_by_usr = cell2mat( cellfun(@(x)pv_auroc(x,1,2),model_data.usr_log(idx,:),'UniformOutput',false) );
% 		pv_kt_by_usr  = cell2mat( cellfun(@(x)pv_auroc(x,1,3),model_data.usr_log(idx,:),'UniformOutput',false) );
		pv_cum_by_usr = cell2mat( cellfun(@(x)pv_accuracy(x,1,2),model_data.usr_log(idx,:),'UniformOutput',false) );
		pv_kt_by_usr  = cell2mat( cellfun(@(x)pv_accuracy(x,1,3),model_data.usr_log(idx,:),'UniformOutput',false) );
% 		pv_cum_by_usr = cell2mat( cellfun(@(x)pv_ssr(x,1,2),model_data.usr_log(idx,:),'UniformOutput',false) );
% 		pv_kt_by_usr  = cell2mat( cellfun(@(x)pv_ssr(x,1,3),model_data.usr_log(idx,:),'UniformOutput',false) );

% 		pv_cum_by_prob = ( cellfun(@(x)pv_auroc(x,1,2),model_data.probl_log));%,'UniformOutput',false) );
% 		pv_kt_by_prob  = ( cellfun(@(x)pv_auroc(x,1,3),model_data.probl_log));%,'UniformOutput',false) );
		pv_cum_by_prob = ( cellfun(@(x)pv_accuracy(x,1,2),model_data.probl_log));%,'UniformOutput',false) );
		pv_kt_by_prob  = ( cellfun(@(x)pv_accuracy(x,1,3),model_data.probl_log));%,'UniformOutput',false) );
% 		pv_cum_by_prob = cell2mat( cellfun(@(x)pv_ssr(x,1,2),model_data.probl_log,'UniformOutput',false) );
% 		pv_kt_by_prob  = cell2mat( cellfun(@(x)pv_ssr(x,1,3),model_data.probl_log,'UniformOutput',false) );

% 		AGGR_PRESENT_glob_cum(group_i,step_i) = pv_auroc( cell2mat(model_data.probl_log), 1, 2);
% 		AGGR_PRESENT_glob_kt(group_i,step_i) = pv_auroc( cell2mat(model_data.probl_log), 1, 3);
		AGGR_PRESENT_glob_cum(group_i,step_i) = pv_accuracy( cell2mat(model_data.probl_log), 1, 2);
		AGGR_PRESENT_glob_kt(group_i,step_i) = pv_accuracy( cell2mat(model_data.probl_log), 1, 3);
% 		AGGR_PRESENT_glob_cum(group_i,step_i) = pv_ssr( cell2mat(model_data.probl_log), 1, 2);
% 		AGGR_PRESENT_glob_kt(group_i,step_i) = pv_ssr( cell2mat(model_data.probl_log), 1, 3);
		
		ALL_by_step{step_i} = [ALL_by_step{step_i}; cell2mat(model_data.probl_log)];

% 		disp([num2str(group_i),'-',num2str(step_i)]);
		AGGR_PRESENT_total_cum_pv_by_usr(group_i,step_i) = mean(pv_cum_by_usr);
		AGGR_PRESENT_total_kt_pv_by_usr(group_i,step_i) = mean(pv_kt_by_usr);
		
		AGGR_PRESENT_total_cum_pv_by_prob(group_i,step_i) = nanmean(pv_cum_by_prob);
		AGGR_PRESENT_total_kt_pv_by_prob(group_i,step_i) = nanmean(pv_kt_by_prob);
		
		line_pv_cum_by_usr = [line_pv_cum_by_usr, pv_cum_by_usr];
		line_pv_cum_by_prob = [line_pv_cum_by_prob, pv_cum_by_prob];
		line_pv_kt_by_usr = [line_pv_kt_by_usr, pv_kt_by_usr];

	end; % for all steps
	sel_usr_mask = [sel_usr_mask; loc_sel_usr_mask];
	
	glob_pv_cum_by_usr  = [glob_pv_cum_by_usr;  line_pv_cum_by_usr];
	glob_pv_cum_by_prob = [glob_pv_cum_by_prob; line_pv_cum_by_prob];
	glob_pv_kt_by_usr   = [glob_pv_kt_by_usr;   line_pv_kt_by_usr];
	
end; % for all groups
% matlabpool close;

% ===== BY USER
% max positions CUM
MAX_glob_pv_cum_by_usr = max(glob_pv_cum_by_usr(:,[2:11]),[],2);
MAX_IDX_glob_pv_cum_by_usr = zeros(size(MAX_glob_pv_cum_by_usr));
MAX_COORD_glob_pv_cum_by_usr = [];
MAX_SIZE_glob_pv_cum_by_usr = zeros(size(MAX_glob_pv_cum_by_usr));
for i=1:size(MAX_glob_pv_cum_by_usr,1),
	MAX_IDX_glob_pv_cum_by_usr(i) = min( find(glob_pv_cum_by_usr(i,[2:11])==MAX_glob_pv_cum_by_usr(i)) );
	MAX_SIZE_glob_pv_cum_by_usr(i) = sum(glob_pv_cum_by_usr(i,[1:11])==MAX_glob_pv_cum_by_usr(i));
	MAX_COORD_glob_pv_cum_by_usr = [MAX_COORD_glob_pv_cum_by_usr, find(glob_pv_cum_by_usr(i,[1:11])==MAX_glob_pv_cum_by_usr(i))];
end;
% max positions KT
MAX_glob_pv_kt_by_usr = max(glob_pv_kt_by_usr(:,[2:11]),[],2);
MAX_IDX_glob_pv_kt_by_usr = zeros(size(MAX_glob_pv_kt_by_usr));
for i=1:size(MAX_glob_pv_kt_by_usr,1),
	MAX_IDX_glob_pv_kt_by_usr(i) = min( find(glob_pv_kt_by_usr(i,[1:11])==MAX_glob_pv_kt_by_usr(i)) );
end;

MAX_IDX_glob_pv_cum_by_usr = MAX_IDX_glob_pv_cum_by_usr + 1;
MAX_IDX_glob_pv_kt_by_usr = MAX_IDX_glob_pv_kt_by_usr + 1;

% IDX_best = mode(MAX_IDX_glob_pv_cum_by_usr);

% % ttest for MAX's
% [h_c,p_c,ci_c,stats_c]=ttest(glob_pv_cum_by_usr(:,1), MAX_glob_pv_cum_by_usr,.05,'left');
% [h_k,p_k]=ttest(glob_pv_kt_by_usr(:,1), MAX_glob_pv_kt_by_usr,.05,'left');
% 
% % ttest for CUM columns
% pvalues_c = zeros(10,1);
% tstat_c = zeros(10,1);
% for i=2:11,
% 	[h,p,ci,stats]=ttest(glob_pv_cum_by_usr(:,1), glob_pv_cum_by_usr(:,i),.05,'left');
% 	pvalues_c(i-1) = p;
% 	tstat_c(i-1) = stats.tstat;
% end;
% 
% % ttest for KT columns
% pvalues_k = zeros(10,1);
% for i=2:11,
% 	[h,p]=ttest(glob_pv_kt_by_usr(:,1), glob_pv_kt_by_usr(:,i),.05,'left');
% 	pvalues_k(i-1) = p;
% end;
% 
% % mu = mean(glob_pv_cum_by_usr);
% % mu_p_s = mu + std(glob_pv_cum_by_usr);
% % mu_m_s = mu - std(glob_pv_cum_by_usr);
% % 
% % figure(1);
% % plot(mu,'b*'); hold on;
% % plot(mu_p_s,'b+');
% % plot(mu_m_s,'b+'); hold off;

% plot(AGGR_PRESENT_total_cum_pv_by_usr');
plot(AGGR_PRESENT_glob_cum');
leg = {};
for i=1:size(groups,1),
	leg = [leg, ['group ',num2str(groups(i)),' (',num2str(sizes(i)),' datapoints)']];
end;
legend(leg);
set(gca,'XTickLabel',{'0','.1','.2','.3','.4','.5','.6','.7','.8','.9','1'});
% ylim([0,1]);

% % ==== other
% % CUM
% % plot(cellfun(@(x)pv_accuracy(x,1,2),ALL_by_step))
% % plot(cellfun(@(x)pv_ssr(x,1,2),ALL_by_step))
% % plot(cellfun(@(x)pv_auroc(x,1,2),ALL_by_step))
% % plot(glob_pv_cum_by_usr');
% % KT
% % plot(cellfun(@(x)pv_accuracy(x,1,3),ALL_by_step))
% % plot(cellfun(@(x)pv_ssr(x,1,3),ALL_by_step))
% % plot(cellfun(@(x)pv_auroc(x,1,3),ALL_by_step))
% % plot(glob_pv_kt_by_usr');
% 
% max_larger_cum = sum(glob_pv_cum_by_usr(:,1) < MAX_glob_pv_cum_by_usr);
% hist(MAX_glob_pv_cum_by_usr - glob_pv_cum_by_usr(:,1));
% sum_diff_cum = sum(MAX_glob_pv_cum_by_usr - glob_pv_cum_by_usr(:,1));
% mean_diff_cum = mean(MAX_glob_pv_cum_by_usr - glob_pv_cum_by_usr(:,1));
% 
% % max_larger_kt = sum(glob_pv_kt_by_usr(:,1) < MAX_glob_pv_kt_by_usr);
% % hist(MAX_glob_pv_kt_by_usr - glob_pv_kt_by_usr(:,1));
% % sum_diff_kt = sum(MAX_glob_pv_kt_by_usr - glob_pv_kt_by_usr(:,1));
% % mean_diff_kt = mean(MAX_glob_pv_kt_by_usr - glob_pv_kt_by_usr(:,1));
% 
% uni = unique(MAX_COORD_glob_pv_cum_by_usr);
% arr = zeros(size(uni));
% for i=1:numel(uni),
% 	arr(i) = sum( MAX_COORD_glob_pv_cum_by_usr == uni(i) );
% end;
% bar(arr);
% set(gca,'XTickLabel',{'0','.1','.2','.3','.4','.5','.6','.7','.8','.9','1'});
% 
% barr = [];
% for i=2:11,
% 	barr(i-1) = mean(glob_pv_cum_by_usr(:,i) - glob_pv_cum_by_usr(:,1));
% end;
% barr = barr';

figure(2);
plot(glob_pv_cum_by_usr(45,:)','k-'); hold on;
plot(glob_pv_cum_by_usr(39,:)','k--');
plot(glob_pv_cum_by_usr(38,:)','k:');
plot(glob_pv_cum_by_usr(29,:)','k-.');
plot(glob_pv_cum_by_usr(22,:)','k.-');
hold off;
legend({'user 1', 'user 2', 'user 3', 'user 4', 'user 5'},3,'fontsize',14);
set(gca,'XTickLabel',{'0','.1','.2','.3','.4','.5','.6','.7','.8','.9','1'});
ylabel('Model accuracy','fontsize',14);
xlabel('User model blend','fontsize',14);

figure(3);
hist(MAX_SIZE_glob_pv_cum_by_usr,[1:11]);
xlabel('Number of "maximum" blends','fontsize',14);
ylabel('Users','fontsize',14);

% group breakdown for 1/3
group_breakdown = [sum(MAX_SIZE_glob_pv_cum_by_usr<=1),...
	sum(and(MAX_SIZE_glob_pv_cum_by_usr>=2,MAX_SIZE_glob_pv_cum_by_usr<=4)),...
	sum(and(MAX_SIZE_glob_pv_cum_by_usr>=5,MAX_SIZE_glob_pv_cum_by_usr<=9)),...
	sum(MAX_SIZE_glob_pv_cum_by_usr>=10)];
idx_low = find(MAX_SIZE_glob_pv_cum_by_usr<=1); 
idx_mid = find(and(MAX_SIZE_glob_pv_cum_by_usr>=2,MAX_SIZE_glob_pv_cum_by_usr<=4));
idx_hi  = find(and(MAX_SIZE_glob_pv_cum_by_usr>=5,MAX_SIZE_glob_pv_cum_by_usr<=9));

% % group breakdown for 10,10
% group_breakdown = [sum(MAX_SIZE_glob_pv_cum_by_usr<=3),...
% 	sum(and(MAX_SIZE_glob_pv_cum_by_usr>=4,MAX_SIZE_glob_pv_cum_by_usr<=6)),...
% 	sum(and(MAX_SIZE_glob_pv_cum_by_usr>=7,MAX_SIZE_glob_pv_cum_by_usr<=9)),...
% 	sum(MAX_SIZE_glob_pv_cum_by_usr>=10)];
% idx_low = find(MAX_SIZE_glob_pv_cum_by_usr<=3); 
% idx_mid = find(and(MAX_SIZE_glob_pv_cum_by_usr>=4,MAX_SIZE_glob_pv_cum_by_usr<=6));
% idx_hi  = find(and(MAX_SIZE_glob_pv_cum_by_usr>=7,MAX_SIZE_glob_pv_cum_by_usr<=9));
% % idx_vhi = find(MAX_SIZE_glob_pv_cum_by_usr>=10);

MAX_COORD_low_pv_cum_by_usr = [];
MAX_COORD_mid_pv_cum_by_usr = [];
MAX_COORD_hi_pv_cum_by_usr = [];
for i=1:size(MAX_glob_pv_cum_by_usr,1),
	if(ismember(i,idx_low))
		MAX_COORD_low_pv_cum_by_usr = [MAX_COORD_low_pv_cum_by_usr, find(glob_pv_cum_by_usr(i,:)==MAX_glob_pv_cum_by_usr(i))];
	elseif(ismember(i,idx_mid)),
		MAX_COORD_mid_pv_cum_by_usr = [MAX_COORD_mid_pv_cum_by_usr, find(glob_pv_cum_by_usr(i,:)==MAX_glob_pv_cum_by_usr(i))];
	elseif(ismember(i,idx_hi)),
		MAX_COORD_hi_pv_cum_by_usr = [MAX_COORD_hi_pv_cum_by_usr, find(glob_pv_cum_by_usr(i,:)==MAX_glob_pv_cum_by_usr(i))];
	end;
end;

pvalues_low = zeros(10,1);
for i=2:11,
	[h,p]=ttest(glob_pv_cum_by_usr(idx_low,1), glob_pv_cum_by_usr(idx_low,i),.05,'left');
	pvalues_low(i-1) = p;
end;

pvalues_mid = zeros(10,1);
tstat_mid = zeros(10,1);
normal_mid = zeros(11,3);
wilcoxon_mid = zeros(10,3);
for i=1:11,
	[h,p,ksstat,cv] = kstest( glob_pv_cum_by_usr(idx_mid,i) );
	normal_mid(i,:) =  [h,p,ksstat];
end;
for i=2:11,
	[h,p,ci,stats]=ttest(glob_pv_cum_by_usr(idx_mid,1), glob_pv_cum_by_usr(idx_mid,i),.05,'left');
	pvalues_mid(i-1) = p;
	tstat_mid(i-1) = stats.tstat;

	[p,h,stats] = signrank(glob_pv_cum_by_usr(idx_mid,1), glob_pv_cum_by_usr(idx_mid,i),'alpha',.05);	
	wilcoxon_mid(i-1,:) = [h, p, stats.signedrank];
end;

pvalues_hi = zeros(10,1);
tstat_hi = zeros(10,1);
wilcoxon_hi = zeros(10,3);
for i=2:11,
	[h,p,ci,stats]=ttest(glob_pv_cum_by_usr(idx_hi,1), glob_pv_cum_by_usr(idx_hi,i),.05,'left');
	pvalues_hi(i-1) = p;
	tstat_hi(i-1) = stats.tstat;
	
	[p,h,stats] = signrank(glob_pv_cum_by_usr(idx_hi,1), glob_pv_cum_by_usr(idx_hi,i),'alpha',.05);	
	wilcoxon_hi(i-1,:) = [h, p, stats.signedrank];
end;

disp(['-- done : in ',num2str(toc(time)),'s --']);
